<script setup lang="ts">
import commonToast from '@/components/common-toast.vue'
import type { LoginRequest } from '@/models/login'
import { commonService } from '@/services/index'
import { useToastStore } from '@/stores/toast'

const isVisible = ref(false)
const accountValue = ref('')
const passwordValue = ref('')

const toastStore = useToastStore()
const toastSetting = ref<'success' | 'error'>('error')

function login() {
  if (!accountValue.value && !passwordValue.value) {
    toastStore.showToast('error', '請輸入帳號和密碼')
    return
  }

  if (!accountValue.value) {
    toastStore.showToast('error', '請輸入帳號')
    return
  }

  if (!passwordValue.value) {
    toastStore.showToast('error', '請輸入密碼')
    return
  }

  const params: LoginRequest = {
    account: accountValue.value,
    password: passwordValue.value
  }

  const res = commonService.login(params)
  console.log(res)
}
</script>

<template>
  <main>
    <div class="container py-5">
      <div class="d-flex justify-content-center">
        <div class="board-card card">
          <div class="card-header d-flex justify-content-between mb-5">
            <div class="text-group">
              <h2 class="font-zh-h2 text-color-main">業務拜訪</h2>
              <h2 class="font-zh-h2">活動管理系統</h2>
            </div>
            <img
              alt="login-illustration"
              class="illustration"
              src="@/assets/images/login-illustration.svg"
            />
          </div>
          <div class="card-body">
            <form class="single-form">
              <div class="input-item">
                <label class="font-zh-p-medium form-label" for="userAccount"
                  >使用者帳號</label
                >
                <input
                  id="userAccount"
                  v-model="accountValue"
                  class="default-input font-zh-p-medium form-control"
                  placeholder="請輸入"
                  type="text"
                />
              </div>
              <div class="input-item mb-5">
                <label class="font-zh-p-medium form-label" for="userPassword"
                  >使用者密碼</label
                >
                <input
                  id="userPassword"
                  v-model="passwordValue"
                  :type="isVisible ? 'text' : 'password'"
                  class="default-input font-zh-p-medium form-control"
                  placeholder="請輸入"
                />
                <div
                  :class="{ active: isVisible }"
                  class="icon-eye"
                  @click="isVisible = !isVisible"
                ></div>
              </div>
              <div class="d-grid gap-2">
                <button
                  class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                  type="button"
                  @click="$router.push('/home')"
                >
                  <p>登入</p>
                  <div class="icon-arrow-right-white"></div>
                </button>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </main>

  <common-toast :toast-setting="toastSetting" />
</template>

<style lang="scss" scoped>
main {
  padding: 32px 0;
  background-image: url('@/assets/images/login-background.svg');
  background-size: cover;
  .illustration {
    margin-top: -80px;
  }
}
</style>
